# -*- coding: utf-8 -*-
"""
Created on Thu May 31 14:22:48 2018

@author: Usuario
"""

import sys
sys.setrecursionlimit(50000)

from pyqtgraph.Qt import QtCore, QtGui

from myWidgets import anal_control_signal, digital_control_signal

from pyqtgraph import dockarea
import pyqtgraph as pg
import telnetlib

from PyQt5.QtCore import QTimer
from PyQt5.QtWidgets import QLCDNumber

#This creates the window for the gui
app = QtGui.QApplication([])
win = QtGui.QMainWindow()
win.setWindowTitle('My GUI')
win.setWindowIcon(QtGui.QIcon('snuffles.png'))

app_icon = QtGui.QIcon()
app_icon.addFile('snuffles.png')
app.setWindowIcon(app_icon)

area = dockarea.DockArea()
win.setCentralWidget(area)
cw = QtGui.QWidget()
win.show()
###############################################################################



# Here I create the layouts
layout397 = pg.LayoutWidget()
layout866 =  pg.LayoutWidget()
layoutPI =  pg.LayoutWidget()
layoutIMG =  pg.LayoutWidget()
layoutWM = pg.LayoutWidget()
layout397_scan = pg.LayoutWidget()
layout866_scan = pg.LayoutWidget()
layout423_scan = pg.LayoutWidget()


# Here I create the docks
s1 = 1
s2 = 1
d397 = dockarea.Dock("Dock397", size=(s1, s2))  
d866 = dockarea.Dock("Dock866", size=(s1, s2))  
dPI = dockarea.Dock("DockPI", size=(s1, s2))   
dWM = dockarea.Dock("DockWM", size=(s1, s2))
d397_scan = dockarea.Dock("Dock 397 scan", size=(s1, s2))
d866_scan = dockarea.Dock("Dock 866 scan", size=(s1, s2))
d423_scan = dockarea.Dock("Dock 423 scan", size=(s1, s2))


# Here I add the docks
area.addDock(d397, 'left')
area.addDock(d866, 'bottom', d397)
area.addDock(dPI, 'bottom', d866)
area.addDock(dWM, 'bottom', dPI)
area.addDock(d397_scan, 'right', d397)
area.addDock(d423_scan, 'right', dPI)
area.addDock(d866_scan, 'right', d866)



# Here I add the layouts to the corresponding dock
d397.addWidget(layout397)
d866.addWidget(layout866)
dPI.addWidget(layoutPI)
dWM.addWidget(layoutWM)
d397_scan.addWidget(layout397_scan)
d866_scan.addWidget(layout866_scan)
d423_scan.addWidget(layout423_scan)


############ creating the controls ########################

piezoA397 = anal_control_signal('piezoA397', 0)
piezoB397 = anal_control_signal('piezoB397', 1)
piezoA866 = anal_control_signal('piezoA866', 2)
piezoB866 = anal_control_signal('piezoB866', 3)
piezoA423 = anal_control_signal('piezoA423', 4)


shutter397 = digital_control_signal('shutter397', 0)
shutter866 = digital_control_signal('shutter866', 2)
shutter423 = digital_control_signal('shutter423', 1)
shutterLED = digital_control_signal('shutterLED', 3)

#Adding the controls:

######### 397 ###########
layout397.addWidget(QtGui.QLabel('397'), 0, 0)
layout397.addWidget(QtGui.QLabel(piezoA397.name), 1, 1), layout397.addWidget(piezoA397.sb, 1, 2)
layout397.addWidget(QtGui.QLabel(piezoB397.name), 2, 1), layout397.addWidget(piezoB397.sb, 2, 2)
layout397.addWidget(QtGui.QLabel(shutter397.name), 3, 1), layout397.addWidget(shutter397.cb, 3, 2)

layout397_scan.addWidget(QtGui.QLabel('397 Scan'), 0, 0)
layout397_scan.addWidget(QtGui.QLabel('start'), 1, 1), layout397_scan.addWidget(piezoA397.scan_sb_start, 1, 2)
layout397_scan.addWidget(QtGui.QLabel('stop'), 2, 1), layout397_scan.addWidget(piezoA397.scan_sb_stop, 2, 2)
layout397_scan.addWidget(QtGui.QLabel('period'), 3, 1), layout397_scan.addWidget(piezoA397.scan_sb_period, 3, 2)
layout397_scan.addWidget(QtGui.QLabel('Scanning'), 4, 1), layout397_scan.addWidget(piezoA397.scan_button, 4, 2)


#########################

######### 866 ###########
layout866.addWidget(QtGui.QLabel('866'), 0, 0)
layout866.addWidget(QtGui.QLabel(piezoA866.name), 1, 1), layout866.addWidget(piezoA866.sb, 1, 2)
layout866.addWidget(QtGui.QLabel(piezoB866.name), 2, 1), layout866.addWidget(piezoB866.sb, 2, 2)
layout866.addWidget(QtGui.QLabel(shutter866.name), 3, 1), layout866.addWidget(shutter866.cb, 3, 2)

layout866_scan.addWidget(QtGui.QLabel('866 Scan'), 0, 0)
layout866_scan.addWidget(QtGui.QLabel('start'), 1, 1), layout866_scan.addWidget(piezoA866.scan_sb_start, 1, 2)
layout866_scan.addWidget(QtGui.QLabel('stop'), 2, 1), layout866_scan.addWidget(piezoA866.scan_sb_stop, 2, 2)
layout866_scan.addWidget(QtGui.QLabel('period'), 3, 1), layout866_scan.addWidget(piezoA866.scan_sb_period, 3, 2)
layout866_scan.addWidget(QtGui.QLabel('Scanning'), 4, 1), layout866_scan.addWidget(piezoA866.scan_button, 4, 2)
#########################

######### PI ###########
layoutPI.addWidget(QtGui.QLabel('Photoion'), 0, 0)
layoutPI.addWidget(QtGui.QLabel(piezoA423.name), 1, 1), layoutPI.addWidget(piezoA423.sb, 1, 2)
layoutPI.addWidget(QtGui.QLabel(shutter423.name), 2, 1), layoutPI.addWidget(shutter423.cb, 2, 2)
layoutPI.addWidget(QtGui.QLabel(shutterLED.name), 3, 1), layoutPI.addWidget(shutterLED.cb, 3, 2)

layout423_scan.addWidget(QtGui.QLabel('423 Scan'), 0, 0)
layout423_scan.addWidget(QtGui.QLabel('start'), 1, 1), layout423_scan.addWidget(piezoA423.scan_sb_start, 1, 2)
layout423_scan.addWidget(QtGui.QLabel('stop'), 2, 1), layout423_scan.addWidget(piezoA423.scan_sb_stop, 2, 2)
layout423_scan.addWidget(QtGui.QLabel('period'), 3, 1), layout423_scan.addWidget(piezoA423.scan_sb_period, 3, 2)
layout423_scan.addWidget(QtGui.QLabel('Scanning'), 4, 1), layout423_scan.addWidget(piezoA423.scan_button, 4, 2)
#########################


######### Here I define the connect functions ###########

def whenChangeAnalog(sb, daq):
    daq.set_out(sb.value())
    
def whenChangeDigital(cb, daq):
    daq.set_out(not cb.isChecked())
    


piezoA397.sb.sigValueChanging.connect(lambda: whenChangeAnalog(piezoA397.sb, piezoA397.AO))
piezoB397.sb.sigValueChanging.connect(lambda: whenChangeAnalog(piezoB397.sb, piezoB397.AO))
piezoA866.sb.sigValueChanging.connect(lambda: whenChangeAnalog(piezoA866.sb, piezoA866.AO))
piezoB866.sb.sigValueChanging.connect(lambda: whenChangeAnalog(piezoB866.sb, piezoB866.AO))
piezoA423.sb.sigValueChanging.connect(lambda: whenChangeAnalog(piezoA423.sb, piezoA423.AO))


shutter397.cb.stateChanged.connect(lambda: whenChangeDigital(shutter397.cb, shutter397.DO))
shutter866.cb.stateChanged.connect(lambda: whenChangeDigital(shutter866.cb, shutter866.DO))
shutter423.cb.stateChanged.connect(lambda: whenChangeDigital(shutter423.cb, shutter423.DO))
shutterLED.cb.stateChanged.connect(lambda: whenChangeDigital(shutterLED.cb, shutterLED.DO))







###########################################################
#all shutter start in False: 
shutters = [shutter397, shutter866, shutter423, shutterLED]
for sh in shutters:
    sh.DO.set_out(True)
    


#read wavemeter
tn = telnetlib.Telnet(host = "wannanosaurus", port = 1234)
tn.write(b'++eos 1\n')

lcd = QLCDNumber()
        
lcd.setDigitCount(9) 
lcd.display("000000 00")
   
def update_label():
    tn.sock_avail()
    tn.write(b'++read <cr>\n')
    a = tn.read_very_eager().decode("utf-8")
    #print(a)
    try:
        lcd.display(a[3:12])
    except:
        lcd.display("000000 00")
    
layoutWM.setGeometry(300, 300, 250, 150)
layoutWM.show()

layoutWM.timer = QTimer()
layoutWM.timer.timeout.connect(update_label)
layoutWM.timer.start(1000)  # every 10,000 milliseconds

layoutWM.addWidget(lcd)
dWM.addWidget(layoutWM)


###############################################################################
import sys
if (sys.flags.interactive != 1) or not hasattr(QtCore, 'PYQT_VERSION'):
    QtGui.QApplication.instance().exec_()